IMPLEMENTATION MODULE Heap;

IMPORT SYSTEM, Storage, WinBase;

VAR
  cs: WinBase.CRITICAL_SECTION;


PROCEDURE ALLOCATE( VAR a: SYSTEM.ADDRESS; l: CARDINAL );
BEGIN
  WinBase.EnterCriticalSection( cs );
  Storage.ALLOCATE( a, l );
  WinBase.LeaveCriticalSection( cs );
END ALLOCATE;

PROCEDURE DEALLOCATE( VAR a: SYSTEM.ADDRESS; l: CARDINAL );
BEGIN
  WinBase.EnterCriticalSection( cs );
  Storage.DEALLOCATE( a, l );
  WinBase.LeaveCriticalSection( cs );
END DEALLOCATE;

BEGIN
  WinBase.InitializeCriticalSection( cs );
END Heap.
